package cn.com.qmth.examcloud.core.oe.student.starter;

import cn.com.qmth.examcloud.commons.util.Util;
import cn.com.qmth.examcloud.core.oe.student.service.impl.ExamControlServiceImpl;
import cn.com.qmth.examcloud.web.support.SpringContextHolder;
import cn.com.qmth.examcloud.web.upyun.UpyunSiteManager;
import cn.com.qmth.examcloud.web.upyun.UpyunTest;
import org.springframework.boot.autoconfigure.EnableAutoConfiguration;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.boot.autoconfigure.domain.EntityScan;
import org.springframework.boot.autoconfigure.web.servlet.MultipartAutoConfiguration;
import org.springframework.cloud.client.discovery.EnableDiscoveryClient;
import org.springframework.cloud.netflix.eureka.EnableEurekaClient;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.ComponentScan;
import org.springframework.context.annotation.Configuration;
import org.springframework.data.jpa.repository.config.EnableJpaAuditing;
import org.springframework.data.jpa.repository.config.EnableJpaRepositories;
import org.springframework.data.mongodb.repository.config.EnableMongoRepositories;
import org.springframework.transaction.annotation.EnableTransactionManagement;
import org.springframework.web.multipart.MultipartResolver;
import org.springframework.web.multipart.commons.CommonsMultipartResolver;

import cn.com.qmth.examcloud.support.cache.CacheHelper;
import cn.com.qmth.examcloud.web.bootstrap.AppBootstrap;

@SuppressWarnings("SpringBootApplicationSetup")
@SpringBootApplication
@Configuration
@EnableAutoConfiguration(exclude = {MultipartAutoConfiguration.class})
@EnableJpaAuditing
@EnableTransactionManagement
@EnableEurekaClient
@EnableDiscoveryClient
@ComponentScan(basePackages = { "cn.com.qmth" })
@EntityScan(basePackages = { "cn.com.qmth" })
@EnableJpaRepositories(basePackages = { "cn.com.qmth" })
@EnableMongoRepositories(basePackages= { "cn.com.qmth" })
public class CoreOeApp {
	static {
		String runtimeLevel = System.getProperty("log.commonLevel");
		if (null == runtimeLevel) {
			System.setProperty("log.commonLevel", "DEBUG");
		}
		System.setProperty("hibernate.dialect.storage_engine", "innodb");
	}

	public static void main(String[] args) {
		AppBootstrap.run(CoreOeApp.class, args);
		UpyunSiteManager.init();
		test();
	/*for(int i=0;i<10000;i++) {
		UpyunTest.testFormApi();
			try {
//				CacheHelper.getSysProperty("oe.examScoreNotify.url.7");
				CacheHelper.getExamRecordProperty(80505L);
				CacheHelper.getExamRecordProperty(9999999999L);
			} catch (Exception e) {
				e.printStackTrace();
			}
			CacheHelper.getExamRecordProperty(80505L);
		}*/
	}

	private static void test() {
		/*for(int i=0;i<99999;i++){
			ExamControlServiceImpl bean = SpringContextHolder.getBean(ExamControlServiceImpl.class);
			try {
				bean.cleanExamRecords();
			} catch (InterruptedException e) {
				e.printStackTrace();
			}
			Util.sleep(5);
		}*/
	}

	@Bean(name = "multipartResolver")
	public MultipartResolver multipartResolver() {
		CommonsMultipartResolver resolver = new CommonsMultipartResolver();
		resolver.setDefaultEncoding("UTF-8");
		resolver.setResolveLazily(true);
		resolver.setMaxInMemorySize(2);
		resolver.setMaxUploadSize(200 * 1024 * 1024);
		return resolver;
	}
}
